SystemOrganization addCategory: #'Orca-Tests'!

OrcaCometClient subclass: #OrcaTestCometClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaTestCometClient class methodsFor: 'configuration' stamp: 'LT 4/12/2011 19:03:35.983'!
defaultMillisecondsToWait

	^ 1000! !

!OrcaTestCometClient class methodsFor: 'configuration' stamp: 'LT 4/12/2011 19:08:14.206'!
maximumTimeWithoutContact

	^ Duration seconds: 1! !

TestCase subclass: #OrcaTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaTestCase subclass: #OrcaAbstractTest
	instanceVariableNames: 'currentRule nilResultAllowed checkResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaAbstractTest subclass: #OrcaAbstractPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaAbstractPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.
	
	self class isOnCIServer ifTrue: [
		{ Object. Number. ProtoObject. OrderedCollection }
			do: [ :class | self class converterClass convertClass: class ]].! !

OrcaAbstractPrinterTest subclass: #OrcaPrettyPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaPrettyPrinterTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrettyPrinter! !

!OrcaPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:41'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'            (function () {
                var cascadeReceiver$ = st.a;
                cascadeReceiver$.b();
                return cascadeReceiver$.c();
            }).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '            (function () {
                var cascadeReceiver$ = st.a;
                cascadeReceiver$.slot_(st.b);
                return cascadeReceiver$.slot_(st.c);
            }).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '            (function () {
                var cascadeReceiver$ = st.a;
                cascadeReceiver$.slot_be_(st.b, st.d);
                return cascadeReceiver$.slot_be_(st.c, st.d);
            }).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 '            return (function () {
                var cascadeReceiver$ = st.Object._new();
                cascadeReceiver$.slot_be_(st.injection, st.string("infovis"));
                return cascadeReceiver$.yourself();
            }).apply(this)'.! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testFunctionCall

	self 
		assertMatches: (OrcaNode functionCall: 
			{OrcaNode identifier: 'b'. 
			#js.
			OrcaNode arguments }) 
		andProduces: 'b.js()';
		
		assertMatches: (OrcaNode functionCall: 
			{OrcaNode identifier: 'b'. 
			#call.
			OrcaNode arguments: { OrcaNode identifier: #b }}) 
		andProduces: 'b.call(b)'.
		! !

!OrcaPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 4/11/2011 16:27'!
testIndention

	self
		assertMatches: '[:e | Js Global alert value: e. [ :f | f + 1 ]. [ :f | f := f + 2. ^ [Js Global alert value: f ] ]]'
		andProduces:  
'            st.block(function (e) {
                st.Js.Global().alert().value_(e);
                st.block(function (f) {
                    return f._plus(st.number(1));
                });
                return st.block(function (f) {
                    f = f._plus(st.number(2));
                    return st.nonLocalReturn(st.block(function () {
                        return st.Js.Global().alert().value_(f);
                    }));
                });
            })'! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testSlotAccess

	self 
		assertMatches: (OrcaNode slotAccess: {OrcaNode identifier: 'a'. #b}) 
		andProduces: 'a.b'.
		
	self
		assertMatches: (OrcaNode slotAccess: {OrcaNode identifier: #'$a'. #'hello_world'})
		andProduces: '$a.hello_world'.! !

!OrcaPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'ag 4/6/2011 15:52'!
testSlotAssignment

	self 
		assertMatches: (OrcaNode expression: 
			{OrcaNode identifier: 'b'.
			OrcaNode slotAccess: 
				{OrcaNode identifier: 'a'. #slot}. 
			}) 
		andProduces: '        a.slot = b'.
		! !

OrcaAbstractPrinterTest subclass: #OrcaPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaPrinterTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrinter! !

!OrcaPrinterTest class methodsFor: 'testing' stamp: 'ag 12/22/2010 13:52'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:41'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		
		assertMatches: 'a b; c'
		andProduces: '(function(){var cascadeReceiver$=st.a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';
		
		assertMatches: 'a b: (a b; d); c'
		andProduces: '(function(){var cascadeReceiver$=st.a;cascadeReceiver$.b_((function(){var cascadeReceiver$=st.a;cascadeReceiver$.b();return cascadeReceiver$.d();}).apply(this));return cascadeReceiver$.c();}).apply(this)'! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:41'!
testEscapingIdentifiers
	
	self
		currentRule: #doItSnippet;
		
		assertMatches: 'Object new'
		andProduces: 'st.Object._new()';
		
		assertMatches: 'a := true'
		andProduces: 'st.a=st.true'.
	
	self class isOnCIServer ifTrue: [
		self assert: ((OrcaCodeFactory new codeForClass: Object) beginsWith: 'Class("_Object",').
		self assert: ((OrcaCodeFactory new codeForClass: Point) beginsWith: 'Class("Point",{superclass:_Object')].! !

!OrcaPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.! !

!OrcaPrinterTest methodsFor: 'test general' stamp: 'ag 4/6/2011 15:52'!
testJsStringPrinting
	
	self
		assert: [ '"\\\"''"' = (OrcaAbstractPrinter asJSString: '\"''')];
		assert: [ '"abc def ()/&%"' = (OrcaAbstractPrinter asJSString: 'abc def ()/&%')];
		assert: [ '"\r"' = (OrcaAbstractPrinter asJSString: String cr)].! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/6/2011 15:52'!
testObjectLiteral

	self 
		assertMatches: (OrcaNode objectLiteral: {})
		andProduces: '{}';

		assertMatches: (
			OrcaNode objectLiteral: {
                    	OrcaNode slotAssignment: 
					{#a. 
					OrcaNode identifier: 'b'}.
                    	OrcaNode slotAssignment:
                       	 	{#b.
                        	OrcaNode functionCall: 
						{OrcaNode functionCall: 
							{OrcaNode identifier: 'a'. 
							#b. 
							OrcaNode arguments}.
						#js.
						OrcaNode arguments}}})
		andProduces: '{a:b,b:a.b().js()}'! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:40'!
testPerformOnServer
	
	self
		assertMatches: '[1] onServer'
		andProduces: 'st.serverBlock("[1]")';
		
		assertMatches: '[:a|1] onServer'
		andProduces: 'st.serverBlock("[:a|1]")';
		
		assertMatches: '[ [ 1 ] onServer ] onServer'
		andProduces: 'st.serverBlock("[ [ 1 ] onServer ]")'.! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:40'!
testPrinting
	
	self
		assert: '1 +/ 2' matches: #binaryExpression andProduces: 'st.number(1)._plus_slash(st.number(2))';
		assert: '{ 1. a b: c. ''s'' }' matches: #braceExpression andProduces: 'st.array([st.number(1), st.a.b_(st.c), st.string("s")])';
		assert: 'a :=   12 a: 12' matches: #expression andProduces: 'st.a=st.number(12).a_(st.number(12))';
		assert: '1 a: 2 b: 3' matches: #keywordExpression andProduces: 'st.number(1).a_b_(st.number(2), st.number(3))';
		assert: '1 a:a b:B. 2 s.' matches: #doItSnippet andProduces: 'st.number(1).a_b_(st.a, st.B);st.number(2).s()';
		assert: '| a b v |' matches: #temporaries andProduces: 'var a;var b;var v';
		assert: '1 bcd' matches: #unaryExpression andProduces: 'st.number(1).bcd()';
		assert: '(1 2 3 ''d  '')' matches: #array andProduces: 'st.array([st.number(1), st.number(2), st.number(3), st.string("d  ")])';
		assert: '#[ 1 2 3 255]' matches: #byteArray andProduces: 'st.array([st.number(1), st.number(2), st.number(3), st.number(255)])';
		assert: '12.3' matches: #number andProduces: 'st.number(12.3)';
		assert: 'self' matches: #reservedWord andProduces: 'this';
		assert: '#a12' matches: #symbol andProduces: 'st.string("a12")'.! !

!OrcaPrinterTest methodsFor: 'test printing' stamp: 'ag 4/12/2011 14:38'!
testSuper
	
	self
		assertMatches: 'super a'
		andProduces: 'st.super("a")()';
		
		assertMatches: 'super a: 1 b: d'
		andProduces: 'st.super("a_b_")(st.number(1), st.d)';
		
		assertMatches: 'a := super'
		andProduces: 'st.a=this';
		
		assertMatches: '^super'
		andProduces: 'return this'.! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:15'!
converterClass
	
	self subclassResponsibility! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultCheckResults
	
	^ true! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:24'!
defaultCurrentRule
	
	^ nil! !

!OrcaAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultNilResultsAllowed
	
	^ false! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'lw 2/22/2011 16:58'!
assert: anObject matches: aRule
	"In most cases, throws an error when failing (hard fail)"
	
	| result |
	result := anObject isString 
		ifTrue: [ self class converterClass convert: anObject as: aRule. ] 
		ifFalse: [ self class converterClass convertAst: anObject ].
	
	self nilResultAllowed ifFalse: [ self assert: result notNil ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'sec 3/23/2011 14:24'!
assert: anObject matches: aRule andProduces: anObjectTree
	"In most cases, throws an error when failing (hard fail). #= Checks collections deeply."
	
	| result |
	result := self assert: anObject matches: aRule.
	result isString ifTrue: [ result := result withSqueakLineEndings ].
	self checkResults ifTrue: [ self assert: result = anObjectTree ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 18:03'!
assert: aString matches: aRule andProducesNode: aCollection
	"Matches the string to the rule and compares the result to an OrcaNode containing the given collection and named like the rule.
	(Follows a convention)."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = (OrcaNode named: aRule asString with: aCollection) ].
	^ result! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertConverting: anInputString containsNodeNamed: aNodeName
	
	^ self assert: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString
	"Checks against the currentRule"
	
	self
		assertFails: aString
		toMatch: self currentRule.! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString toMatch: aRule
	
	self
		should: [ self assert: aString matches: aRule ]
		raise: OM2Fail
		description: 'Matching should have failed but didn''t!!'.! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertMatches: aString
	"Check against the currentRule"
	
	^ self assert: aString matches: self currentRule! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProduces: anObject
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProduces: anObject! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProducesNode: aCollection
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProducesNode: aCollection! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults
	^ checkResults! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults: aBoolean
	checkResults := aBoolean! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule
	^ currentRule! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule: aSymbol
	currentRule := aSymbol! !

!OrcaAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:56'!
denyConverting: anInputString containsNodeNamed: aNodeName
	
	self deny: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
exampleMethod1
	
	"Comment"
	self class.
	^ [ Js Global alter: 'example'].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:54'!
exampleMethod2
	
	| |
	< primitiveDecl: 1 >
	"Comment"
	self class.
	self
		a: 1;
		b: 2;
		c.
	^ [ Js Global alert: 'example'].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
""exampleMethod3""
	""
	""<"" primitiveDecl: ""1 "">""
	""
	""| ""temporariesAfterPrimitiveDecl"" |""
	"Comment"
	""self"" class"".""
	self""
		""a:"" 1"";""
		""b: ""2"";""
		""c"".""
	""^"" [""Js Global ""alter:"" 'example'""]"".""! !

!OrcaAbstractTest methodsFor: 'initialization' stamp: 'ag 12/13/2010 09:24'!
initialize
	
	super initialize.
	self
		nilResultAllowed: self class defaultNilResultsAllowed;
		checkResults: self class defaultCheckResults;
		currentRule: self class defaultCurrentRule.! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
nilResultAllowed
	^ nilResultAllowed! !

!OrcaAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
nilResultAllowed: aBoolean
	nilResultAllowed := aBoolean! !

!OrcaAbstractTest methodsFor: 'private' stamp: 'ag 4/6/2011 15:52'!
performTest
	
	self class = OrcaAbstractTest | (self class = OrcaTestCase) | (self class = OrcaAbstractPrinterTest)
		ifTrue: [ "Just ignore the abstract tests" ]
		ifFalse: [ super performTest ].! !

!OrcaAbstractTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:00'!
testExampleMethods
	
	self class converterClass
		convertMethod: #exampleMethod1 of: self class;
		convertMethod: #exampleMethod2 of: self class;
		convertMethod: #exampleMethod3 of: self class.! !

OrcaAbstractTest subclass: #OrcaParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaParserTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaParser! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testArray
	
	self
		currentRule: #array;
		
		assertMatches: '()' andProducesNode: {};
		assertMatches: '(:)' andProducesNode: { OrcaNode symbol: #: };
		assertMatches: '(  )  ' andProducesNode: {};
		assertMatches: '( 2. 1) ';
		assertMatches: '( 2. 1 [ ] ^ 23 { } ) ';
		assertMatches: '(  1 2   3) ' andProducesNode: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode number: 3};
		assertMatches: '(''aa'' 1 ''b1'' 32)' andProducesNode: 
			{OrcaNode string: 'aa'. OrcaNode number: 1. OrcaNode string: 'b1'. OrcaNode number: 32};
		assertMatches: '(#abc     11    ''a''   )' andProducesNode: 
			{OrcaNode symbol: #abc. OrcaNode number: 11. OrcaNode string: 'a'};
		assertMatches: '(  ( 1 2 3    ''2'')   #a  ''c''   )' andProducesNode: 
			{OrcaNode array: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode number: 3. OrcaNode string: '2'}.
			OrcaNode symbol: #a. OrcaNode string: 'c'};
		assertMatches: '($a     11    ''a''   #a2   #(1 2   $2) )  ' andProducesNode: { OrcaNode character: $a. OrcaNode number: 11. OrcaNode string: 'a'. OrcaNode symbol: #a2. OrcaNode array: {OrcaNode number: 1. OrcaNode number: 2. OrcaNode character: $2}};
		assertMatches: '( a )' andProducesNode: { OrcaNode symbol: #a};
		assertMatches: '( a b )' andProducesNode: {OrcaNode symbol: #a. OrcaNode symbol: #b} ;
		assertMatches: '(d ((b ((a))) (c)))' andProducesNode: {OrcaNode symbol: #d. OrcaNode array: {OrcaNode array: {OrcaNode symbol: #b. 
			OrcaNode array: {OrcaNode array: {OrcaNode symbol: #a}}}. OrcaNode array: {OrcaNode symbol: #c}}};
		assertMatches: '( self a:bc == |? ?!!!! )  ' andProducesNode: {OrcaNode symbol: #self. OrcaNode symbol: #'a:bc'. 
			OrcaNode symbol: #'=='. OrcaNode symbol: #'|'. OrcaNode symbol: #'?'. OrcaNode symbol: #'?!!!!'};
		assertMatches: '( self #( aa 1 ) ( ''a'' #1 #ab: ab:))  ' andProducesNode: { OrcaNode symbol: #self. OrcaNode array: {OrcaNode symbol: #aa. OrcaNode number: 1. }. OrcaNode array: { OrcaNode string: 'a'. OrcaNode number: 1. OrcaNode symbol: #'ab:'. OrcaNode symbol: #'ab:' }} ;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '(';
		assertFails: '#()';
		assertFails: '#(';
		assertFails: '{1}';
		assertFails: ' ( 1 2  )'. "Should not read prepended spaces"! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBinaryExpression
	
	self
		currentRule: #binaryExpression;
		
		assertMatches: 'a+b' andProducesNode:  (OrcaNode binaryExpression: { OrcaNode identifier: 'a' . #+. OrcaNode identifier: 'b'} );
		assertMatches: '1 * b' andProducesNode: (OrcaNode binaryExpression: 
			{OrcaNode number: 1 .#* . OrcaNode identifier: 'b'});
		assertMatches: '1 \ b / c' andProducesNode: 
			(OrcaNode binaryExpression: 
				{ OrcaNode binaryExpression: {  OrcaNode number: 1.  #\  . 
				OrcaNode identifier: 'b'} . #/ . OrcaNode identifier: 'c'} );
		
		assertFails: 'a 2';
		assertFails: 'a: 2';
		assertFails: '+ 2'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testBinarySelector
	"Would be cool to find all the binary messages in the image and test them..."
	
	self
		currentRule: #binarySelector;
		
		"special cases: single pipe and single minus"
		assertMatches: '|' andProduces: #|;
		assertMatches: '-' andProduces: #-;
		
		"names starting with a minus"
		assertMatches: '-*' andProduces: #-*;
		assertMatches: '-***' andProduces: #-***;
		assertMatches: '-*%&' andProduces: #-*%&;
		assertMatches: '-*/\' andProduces: #-*/\;
		assertMatches: '-!!?' andProduces: #-!!?;
		assertMatches: '-==' andProduces: #-==;
		
		"mixed characters, check each one"
		assertMatches: '*+' andProduces: #*+;
		assertMatches: '/=\' andProduces: #/=\;
		assertMatches: '~,,,<' andProduces: #~,,,<;
		assertMatches: '>@' andProduces: #>@;
		assertMatches: '%&' andProduces: #%&;
		assertMatches: '?!!' andProduces: #?!!;
		assertMatches: '``' andProduces: #``;
		assertMatches: '+??=' andProduces: #+??=;
		assertMatches: ',!!!!,' andProduces: #,!!!!,;
		
		"Not allowed things"
		assertFails: '';
		assertFails: ' ';
		assertFails: 'w';
		assertFails: '2';
		assertFails: '--';
		assertFails: '||';
		assertFails: '|--';
		assertFails: '%--';
		assertFails: '%||';
		assertFails: '&-&-';
		assertFails: '- %';
		assertFails: ' -';
		assertFails: '& &';
		assertFails: 'w a';
		assertFails: '- -';
		assertFails: '#a a';
		assertFails: '#aa 2'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBlock
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProducesNode: { };
		assertMatches: '[  ]' andProducesNode: { };
		assertMatches: '[||]' andProducesNode: {OrcaNode temporaries};
		assertMatches: '[:a|||]' andProducesNode: 
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries};
		assertMatches: '[||a]' andProducesNode: {OrcaNode temporaries. OrcaNode statements: {OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[:a|||a]' andProducesNode:
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries. OrcaNode statements: { OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[:a||a|a]' andProducesNode: 
			{ OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode temporaries: { OrcaNode identifier: 'a'}. 
			OrcaNode statements: { OrcaNode expression: { OrcaNode identifier: 'a'}}};
		assertMatches: '[:a|a|a|a]' andProducesNode:
			{ OrcaNode arguments: { OrcaNode identifier: 'a' }. OrcaNode statements:
				{ OrcaNode expression: { OrcaNode binaryExpression: { OrcaNode binaryExpression: 
					{ OrcaNode identifier: 'a'. #|. OrcaNode identifier: 'a' }. #| . 
					OrcaNode identifier: 'a'.  }}}};
		assertMatches: '[ :a ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'}};
		assertMatches: '   [ :a ]  ' andProducesNode: {OrcaNode arguments: { OrcaNode identifier: 'a'}};
		assertMatches: '[ :a :b ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'. OrcaNode identifier: 'b'}};
		assertMatches: '[ :a  :b | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'. OrcaNode identifier: 'b'}};
		assertMatches: '  [   :a |   |  a  |   ]  ' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'a'}. 
			OrcaNode temporaries: {OrcaNode identifier: 'a'}};
		assertMatches: '[  :a  | a ]  ' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. 
			OrcaNode statements: {OrcaNode expression: {OrcaNode identifier: 'a'}}};
		assertMatches: '[ :a  | a. ^ 1 ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode statements:
				{OrcaNode expression: {OrcaNode identifier: 'a'}. OrcaNode returnExpression: {OrcaNode number: 1}}};
		assertMatches: '[  :a  |  1  ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'a'}. OrcaNode statements: {OrcaNode expression: {OrcaNode number: 1}}};
		assertMatches: '[  :b  |   []  ]' andProducesNode:
			{OrcaNode arguments: {OrcaNode identifier: 'b'}. OrcaNode statements: {OrcaNode expression: { OrcaNode block}}};
		
		"Can also leave spaces between : and the argument-name !!"
		assertMatches: '[ :  i | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'i'}};
		assertMatches: '[ :  i :  d | ]' andProducesNode: {OrcaNode arguments: {OrcaNode identifier: 'i'. OrcaNode identifier: 'd'}};
		
		assertFails: '[]]';
		assertFails: '[[]';
		assertFails: '[::a]';
		assertFails: '[ :a | b';
		assertFails: '[ :a |||| b]';
		assertFails: '[ | :a | b]';
		assertFails: '[ || :a | b]';
		assertFails: '[ :a || b]';
		assertFails: '[ :a | :b  ]';
		assertFails: '[ :a || :b|]';
		assertFails: '[ :a | b| :a]';
		assertFails: '[ :a :1 | b]';
		assertFails: '[ aaaa"] ';
		assertFails: '[ "aaa"a"] ';
		assertFails: '[ "aaaa] '.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testBraceExpression
	
	self
		currentRule: #braceExpression;
		
		assertMatches: '{}' andProducesNode: { };
		assertMatches: '  {  }   ' andProducesNode: { };
		assertMatches: '{1}' andProducesNode: {OrcaNode expression: {OrcaNode number: 1}};
		assertMatches: '  {  11 }  ' andProducesNode: {OrcaNode expression: {OrcaNode number: 11}};
		assertMatches: '  {  11. }  ' andProducesNode: {OrcaNode expression: { OrcaNode number: 11}};
		assertMatches: '{ 1.   2}' andProducesNode: {OrcaNode expression: 
			{OrcaNode number: 1}. OrcaNode expression: { OrcaNode number: 2 }};
		assertMatches: '{1.2}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1.2 }};
		assertMatches: '{1. 2}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1 }. 
			OrcaNode expression: { OrcaNode number: 2 }};
		assertMatches: '{1. ''.'' .}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1}. 
			OrcaNode expression: { OrcaNode string: '.' }};
		assertMatches: '{1  .  2  .}' andProducesNode: { OrcaNode expression: { OrcaNode number: 1}. 
			OrcaNode expression: { OrcaNode number: 2 }};		
		
		assertFails: '.{}.';
		assertFails: '{1 .. 2}';
		assertFails: '{ 1  . 2 ..}';
		assertFails: '{.1.2}';
		assertFails: '{..1.}';
 		assertFails: '{ "bb}';
 		assertFails: '{ "b "   .  b"}'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testByteArray
	
	self
		currentRule: #byteArray;
		
		assertMatches: '#[1]' andProducesNode: {1};
		assertMatches: '#  [  1  ]  ' andProducesNode: {1};
		assertMatches: '#[]' andProducesNode: {};
		assertMatches: '#   [1 2 3 ]' andProducesNode: {1. 2. 3.};
		assertMatches: '#[255 000 000 123 255]' andProducesNode: {255. 0. 0. 123. 255};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#[ 1';
		assertFails: '  #[ 1 ]';
		assertFails: '# [ 1.2 ]';
		assertFails: '#[ 256 1 00]';
		assertFails: '#[ -1 ]';
		assertFails: '#[ +1 ]';
		assertFails: '#[ #[ 1 ] ]  ';
		assertFails: '#( 255 )'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		assertMatches: 'Transcript  show:2;cr' andProducesNode: (OrcaNode cascadedExpression:
				{ OrcaNode identifier: 'Transcript'.  OrcaNode keywordExpression: {#show: . OrcaNode number: 2}. OrcaNode unaryExpression: {#cr}});
		"assertMatches: 'Transcript  show:2 ""Comment"";cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier:' with:{'Transcript'}. self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unarayExpression' with:{self node:'comment' with:{'Comment'} . #cr} } );" "comments are not yet stored correctly"

		assertFails: 'Transcript  show:2 "Comment;cr';				
		assertFails: 'Transcript show:1'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testCharacter
	
	self
		currentRule: #character;
		
		assertMatches: '$c' andProducesNode: { $c };
		assertMatches: '$&' andProducesNode: { $& };
		assertMatches: '$ ' andProducesNode: { $ };
		assertMatches: '$`' andProducesNode: { $` };
		assertMatches: 'Character space' andProducesNode: { $  };
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'a';
		assertFails: '`';
		assertFails: ' $a';
		assertFails: '$$$';
		assertFails: '$  a';
		assertFails: '$av';
		assertFails: '$ a'.! !

!OrcaParserTest methodsFor: 'test general' stamp: 'lw 4/6/2011 18:05'!
testComments
	true ifTrue: [ ^ self ].
	self
		
		currentRule: #block;
		
		assertMatches: '"aaaaa" "aaa"[]'  andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaaaa'}. OrcaNode comments: {OrcaNode comment: 'aaa'}. OrcaNode block: {}};
		assertMatches: '"aaaaa" ["a aa"]'  andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaaaa'}. OrcaNode block: {OrcaNode comments: {OrcaNode comment: 'a aa'}} };
		assertMatches: '[ "a aaa"] '  andProducesNode: { OrcaNode block: {OrcaNode comments: {OrcaNode comment: 'a aaa'}} };
		assertMatches: '"aaa"{ "bbb"}' andProducesNode: { OrcaNode comments: {OrcaNode comment: 'aaa'}. OrcaNode braceExpression: { OrcaNode comments: {OrcaNode comment: 'bbb'}}};
		assertMatches: '# "adsd" eins "asdads"' andProducesNode: { OrcaNode symbol: {OrcaNode comments: {OrcaNode comment: 'adsd'}. #eins}. OrcaNode comments: {OrcaNode comment: 'asdads'}};

		
		currentRule: #binaryExpression;
		assertMatches: '1 "Comment "* b' andProducesNode: (OrcaNode binaryExpression: 
			{  OrcaNode number: 1. OrcaNode comments: {OrcaNode comment: 'Comment '}. #*. 
			OrcaNode identifier: 'b'}).! !

!OrcaParserTest methodsFor: 'test general' stamp: 'lw 4/6/2011 18:05'!
testExampleMethods
	
	super testExampleMethods! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testExpressionAssignment
	
	self
		currentRule: #expression;
		
		assertMatches: 'a' andProducesNode: { OrcaNode identifier: 'a'};
		assertMatches: 'a := b' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: '  a   :=   b  ' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: 'a := b := c := 1' andProducesNode: { OrcaNode number: 1. 
			 OrcaNode identifier: 'a'. OrcaNode identifier: 'b'. OrcaNode identifier: 'c'};
		assertMatches: '  a    :=  b  :=  c :=   1' andProducesNode: {OrcaNode number: 1. 
			 OrcaNode identifier: 'a'. OrcaNode identifier: 'b'. OrcaNode identifier: 'c'};
		assertMatches: 'a _ b' andProducesNode: { OrcaNode identifier: 'b'. 
			 OrcaNode identifier: 'a'};
		assertMatches: 'a := 1';
		assertMatches: 'a := b := 1';
		assertMatches: 'a := b := c := d';
		assertMatches: '   a     :=      a     ';
		assertMatches: '   a     _   1 ';
		assertMatches: 'a:=1';
		assertMatches: 'a:=1.0';
		assertMatches: 'a:=b:=1.0';
		assertMatches: 'a_v_1';
		
		assertFails: 'a : = b';
		assertFails: ' := b';
		assertFails: 'a := ';
		assertFails: 'a := b :=';
		assertFails: 'a := b := 1 := a';
		assertFails: 'a := := b   ';
		assertFails: 'a _ _ b';
		assertFails: 'a __ b';
		assertFails: 'a :=:= b';
		assertFails: 'a := b v := a';
		assertFails: 'a  b := a ';
		assertFails: 'a := 1 := b';
		assertFails: 'a: := b';
		assertFails: 'a: _ b';
		assertFails: 'a :_ b';
		assertFails: 'a := 1 := 2:=f';
		assertFails: 'a __ b';
		assertFails: 'a : = b'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testIdentifier
	
	self
		currentRule: #identifier;
		
		assertMatches: 'abc' andProducesNode: {'abc'};
		assertMatches: 'a1' andProducesNode: {'a1'};
		assertMatches: '1' andProducesNode: {'1'};
		assertMatches: 'aaaaaaaa1233333' andProducesNode: {'aaaaaaaa1233333'};
		assertMatches: '' andProducesNode: {''};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testKeywordSelector
	
	self
		currentRule: #keyword;
		
		assertMatches: 'abc:' andProduces: #abc:;
		assertMatches: 'a1:' andProduces: #a1:;
		assertMatches: '1:' andProduces: #1:;
		assertMatches: 'aaaaaaaa1233333:' andProduces: #aaaaaaaa1233333:;
		assertMatches: ':' andProduces: #:;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc';
		assertFails: 'abc<<'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testMethod
	
	self
		currentRule: #method;
		
		assertFails: 'a |a| <p> |a|'. "Don't allow two temporaries-declarations"! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testNumber
	
	self
		currentRule: #number;
		
		assertMatches: '1' andProducesNode: {1};
		assertMatches: '0' andProducesNode: {0};
		assertMatches: '123' andProducesNode: {123};
		assertMatches: '112345678' andProducesNode: {112345678};
		assertMatches: '000' andProducesNode: {0};
		assertMatches: '-000' andProducesNode: {0};
		assertMatches: '-1' andProducesNode: {-1};
		assertMatches: '-1.22' andProducesNode: {-1.22};
		assertMatches: '1.22e23' andProducesNode: {1.22e23};
		assertMatches: '122e23' andProducesNode: {12200000000000000000000000};
		assertMatches: '35r35' andProducesNode: {35r35};
		assertMatches: '-35r35' andProducesNode: {-35r35};
		assertMatches: '22r12.12' andProducesNode: {22r12.12};
		assertMatches: '22r12.12e12' andProducesNode: {22r12.12e12};
		assertMatches: '-22r-12.12e12' andProducesNode: {-22r-12.12e12};
		assertMatches: '22r-12.12e12' andProducesNode: {22r-12.12e12};
		assertMatches: '-22r12.12e12' andProducesNode: {-22r12.12e12};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '+1';
		assertFails: '+1.2';
		assertFails: '+23r23.3';
		assertFails: '+23r+233.3';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: 'abc';
		assertFails: '<<'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testPrimitiveDeclaration
	
	self
		currentRule: #primitiveDeclaration;
		
		assertMatches: '<a:1b:1>';
		assertMatches: '<a>';
		assertMatches: '<  a>';
		assertMatches: '  <  a  >';
		assertMatches: '< | 1>';
		assertMatches: '< == 2>';
		assertMatches: '<  var: ''anc'' >';
		assertMatches: '< & ''add''>';
		assertMatches: '< abc: 22 dfe: 23>';
		
		assertFails: '<1>';
		assertFails: '< 1 2 >';
		assertFails: '<a: 1 1>';
		"assertFails: '<v: d>';" "These should not match, but match currently. Never mind, is not allowed by the compiler"
		"assertFails: '<d: 2 d: e>';"
		"assertFails: '< | d >';"
		assertFails: '<''2''>';
		assertFails: '<| 1>';
		assertFails: '<< 2>';
		assertFails: '< > 2>';
		assertFails: '<> 2>';
		assertFails: '< a: 2 ';
		assertFails: '< a ';
		assertFails: '< | 2 '.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testReservedWord
	
	self
		currentRule: #statements;
		
		assertConverting: '1 a; b: self; c' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. self}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. nil}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{true|nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil.{true}}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. self2. true12}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. aNself}' containsNodeNamed: 'reservedWord';
		denyConverting: '#(1 self super)' containsNodeNamed: 'reservedWord';
		assertConverting: '#(true)' containsNodeNamed: 'reservedWord';
		
		currentRule: #primary;
		
		assertConverting: '(self)' containsNodeNamed: 'reservedWord';
		assertConverting: '(self/1)' containsNodeNamed: 'reservedWord';
		assertConverting: '([self])' containsNodeNamed: 'reservedWord';
		assertConverting: '([self.])' containsNodeNamed: 'reservedWord';
		assertMatches: '(self2)' andProduces: (OrcaNode paranthesizedExpression: { OrcaNode identifier: 'self2' });
		denyConverting: '([self2])' containsNodeNamed: 'reservedWord'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testStatements

	"TODO Not complete test !! Write more !! " 
	
	self
		currentRule: #statements;
		nilResultAllowed: true;
		
		assertMatches: '...';
		assertMatches: 'a. b. ^ c';
		assertMatches: 'a.b.c';
		assertMatches: '1 a. b d: d d: 1. 2. ^ a d: d f: 2';
		assertMatches: '  a  .  b   .. . . . .. . . . .   c.  ^ 1.';
		
		assertFails: ' a. ^ 1...';
		assertFails: ' 1. a ^ 1';
		assertFails: '^ d d. 1';
		assertFails: '^ .';
		assertFails: '^....';
		assertFails: '^^'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testString
	
	self
		currentRule: #string;
		
		assertMatches: '''a''' andProduces: (OrcaNode string: 'a');
		assertMatches: '''''' andProduces: (OrcaNode string: '');
		assertMatches: '''123''' andProduces: (OrcaNode string: '123');
		assertMatches: ''' '''' '''' ''' andProduces: (OrcaNode string: ' '' '' ');
		assertMatches: '''''''123''' andProduces: (OrcaNode string: '''123');
		assertMatches: '''    ''' andProduces: (OrcaNode string: '    ');
		assertMatches: '''"$%&''' andProduces: (OrcaNode string: '"$%&');
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: ''' ''a';
		assertFails: ' ''''';
		assertFails: 'a''''';
		assertFails: '''as';
		assertFails: 'as''';
		assertFails: ''' '' ''';
		assertFails: '''a '' a''';
		assertFails: '''/'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'ag 4/6/2011 18:09'!
testSymbol
	
	"TODO extend test, if stringS2 J gets extended to support '' inside of a string"
	"Edit -- no idea what that comment means and what strinS2 J is"
	
	self
		currentRule: #symbol;
		
		assertMatches: '#abc' andProducesNode: {#abc};
		assertMatches: '# ''''' andProducesNode: {#''};
		assertMatches: '#   abc' andProducesNode: {#  abc};
		assertMatches: '#abc1' andProducesNode: {#abc1};
		assertMatches: '#a' andProducesNode: {#a};
		assertMatches: '#''a''' andProducesNode: {#a};
		assertMatches: '#''a b c''' andProducesNode:  {#'a b c'};
		assertMatches: '#''''' andProducesNode: {#''};
		assertMatches: '#''123''' andProducesNode:  {#'123'};
		assertMatches: '#''    ''' andProducesNode: {#'    '};
		assertMatches: '#''"$%&''' andProducesNode: {#'"$%&'};
		assertMatches: '#abc1:' andProducesNode: {#abc1:};
		assertMatches: '#|' andProducesNode: {#|};
		assertMatches: '#-&&' andProducesNode: {#-&&};
		assertMatches: '#-' andProducesNode: {#-};
		assertMatches: '#a:b:c1' andProducesNode: {#a:b:c1};
		assertMatches: '#:' andProducesNode: {#:};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'abc';
		assertFails: '#1abc';
		assertFails: '#""';
		assertFails: '#'' ''a';
		assertFails: '#a''''';
		assertFails: '#''as';
		assertFails: '#as''';
		assertFails: '#'' '' ''';
		assertFails: '#''a '' a''';
		assertFails: '#123';
		assertFails: '###';
		assertFails: '#''/'.! !

!OrcaParserTest methodsFor: 'test complex' stamp: 'lw 4/6/2011 18:05'!
testUnaryExpression
	
	self
		currentRule: #unaryExpression;
		
		assertMatches: 'a b' andProducesNode: { OrcaNode identifier: 'a'. #b };
		assertMatches: '1 b' andProducesNode: { OrcaNode number: 1. #b };
		assertMatches: 'a b c' andProducesNode: { OrcaNode unaryExpression: { OrcaNode identifier: 'a'. #b }. #c };
		assertMatches: ' a  b c d ' andProducesNode: { OrcaNode unaryExpression: { OrcaNode unaryExpression: { OrcaNode identifier: 'a'. #b }. #c }. #d };
		assertMatches: '   ''abc''    b1     ' andProducesNode: { OrcaNode string: 'abc'. #b1 };
		
		assertFails: '';
		assertFails: '  ';
		assertFails: 'a';
		assertFails: '  a  ';
		assertFails: 'a  1';
		assertFails: 'a b 1';
		assertFails: 'a || b';
		assertFails: 'a % b';
		assertFails: 'a -|';
		assertFails: 'a b > a';
		assertFails: 'a unary>'.! !

!OrcaParserTest methodsFor: 'test tokens' stamp: 'lw 4/6/2011 18:05'!
testUnarySelector
	"Would be cool to find all the unary messages in the image and test them..."
	
	self
		currentRule: #unarySelector;
		
		assertMatches: 'abc' andProduces: #abc;
		assertMatches: 'a1' andProduces: #a1;
		assertMatches: '1' andProduces: #1;
		assertMatches: 'aaaaaaaa1233333' andProduces: #aaaaaaaa1233333;
		assertMatches: '' andProduces: #;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

OrcaAbstractTest subclass: #OrcaSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/12/2011 16:22'!
assert: objectTree isSerializedTo: jsCode
	
	self assert: jsCode = objectTree serializeToJavaScript.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/12/2011 16:21'!
testNestedObjectSerialization
	
	| var1 var2 var3 |
	var1 := OrcaSerializationTestObject new.
	var2 := OrcaSerializationTestObject new.
	var3 := OrcaSerializationTestObject new.
	var1 otherObject: var2.
	var2 otherObject: var3.
	var3 otherObject: var1.
	self
		assert: var1
		isSerializedTo: 
			'var obj3=st.OrcaSerializationTestObject._newInstance();',
			'var obj2=st.OrcaSerializationTestObject._newInstance();',
			'var obj1=st.OrcaSerializationTestObject._newInstance();',
			'obj3.$otherObject=obj1;',
			'obj2.$otherObject=obj3;',
			'obj1.$otherObject=obj2;',
			'return obj1;'.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/12/2011 16:23'!
testObjectSerialization
	
	self
		assert: (1)
		isSerializedTo: 'var obj1=st.number(1);return obj1;';
		
		assert: ({})
		isSerializedTo: 'var obj1=st.Array._newInstance();obj1.original$=[];return obj1;';
		
		assert: ({1. 'a'})
		isSerializedTo: 'var obj3=st.string("a");var obj2=st.number(1);var obj1=st.Array._newInstance();obj1.original$=[obj2, obj3];return obj1;';
		
		assert: (nil)
		isSerializedTo: 'var obj1=st.nil;return obj1;'.! !

!OrcaSerializationTest methodsFor: 'testing' stamp: 'ag 4/12/2011 16:22'!
testSlotObjectSerialization
	
	self
		assert: ({} asObject)
		isSerializedTo: 'var obj1={};st.unboxSlotObject(obj1);return obj1;';
		
		assert: ({#a -> 1. #b -> 2} asObject)
		isSerializedTo: 'var obj3=st.number(2);var obj2=st.number(1);var obj1={};obj1.a=obj2;obj1.b=obj3;st.unboxSlotObject(obj1);return obj1;'.! !

OrcaAbstractTest subclass: #OrcaSqueakAstToJsAstTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSqueakAstToJsAstTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaSqueakAstToJsAst! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:35'!
testBlockArgument
	
	self
		currentRule: #block;
		
		assertMatches: '[]' 
		andProduces: (OrcaNode functionCall: 
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: {OrcaNode arguments. OrcaNode functionContent: {}}}});
		
		assertMatches: '[1]' 
		andProduces: (OrcaNode functionCall:  
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments. 
					OrcaNode functionContent: 
						{ OrcaNode returnExpression: 
							{ OrcaNode functionCall: 
								{ nil. 'st.number'. 
								OrcaNode arguments: { OrcaNode number: 1 }}}}}}});
								
		assertMatches: '[^''1'']' 
		andProduces: (OrcaNode functionCall:  
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments. 
					OrcaNode functionContent: 
						{ OrcaNode returnExpression: 
							{ OrcaNode functionCall: 
								{ nil.
								'st.nonLocalReturn'.
								OrcaNode arguments: 
									{ OrcaNode functionCall: 
										{ nil.
										'st.string'. 
										OrcaNode arguments: {OrcaNode string:  '1' }}}}}}}}});
		
		assertMatches: '[:a]' 
		andProduces: (OrcaNode functionCall: 
			{nil. 'st.block'. OrcaNode arguments: 
				{OrcaNode functionDeclaration: {OrcaNode arguments: { OrcaNode identifier: 'a' }. OrcaNode functionContent: {}}}}).! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test treequality' stamp: 'ag 4/12/2011 14:38'!
testNestedExpressions

	self 
		currentRule: #expression;
		
		assertMatches: (OrcaNode expression) 
		andProduces: (OrcaNode expression);
		
		assertMatches: (OrcaNode expression: {OrcaNode expression}) 
		andProduces: (OrcaNode expression);
		
		assertMatches: (OrcaNode expression: 
			{OrcaNode expression. OrcaNode identifier: 'a'}) 
		andProduces: (OrcaNode expression: {OrcaNode identifier: 'st.a'});
			
		assertMatches: (OrcaNode expression: {OrcaNode returnExpression: {}}) 
		andProduces: (OrcaNode returnExpression: {})! !

!OrcaSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:35'!
testNonLocalReturn
	
	self
		currentRule: #block;
		
		assertMatches: 
			'[ [^ ''returned nonlocally''] value ]'
		 andProduces: (OrcaNode functionCall: 
			{nil.
			'st.block'.
			OrcaNode arguments: 
				{OrcaNode functionDeclaration: 
					{ OrcaNode arguments.
					OrcaNode functionContent: 
						{OrcaNode returnExpression: 
						{OrcaNode functionCall: 
							{ OrcaNode functionCall: 
								{nil. 
								'st.block'.
								OrcaNode arguments: 
									{OrcaNode functionDeclaration: 
										{OrcaNode arguments.
										OrcaNode functionContent:
											{ OrcaNode returnExpression:  
												{ OrcaNode functionCall: 
													{nil. 
													'st.nonLocalReturn'. 
													OrcaNode arguments: 
														{ OrcaNode functionCall: 
															{ nil. 
															'st.string'. 
															OrcaNode arguments: {OrcaNode string: 'returned nonlocally'}}}}}}}}}.
							'value'. OrcaNode arguments}}}}}})
		
		
	"expected JavaScript: st.block(function(){return st.block(function(){st.nonLocalReturn('returned nonlocally')}).value() }, this)"! !

OrcaAbstractTest subclass: #OrcaTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaTranslatorTest class methodsFor: 'testing' stamp: 'ag 4/6/2011 15:52'!
converterClass
	
	^ OrcaPrinter! !

!OrcaTranslatorTest class methodsFor: 'testing' stamp: 'lw 2/21/2011 13:17'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:20'!
testAddition
	
	self
		assertMatches: '3+4'
		andProduces: 'st.number(3)._plus(st.number(4))'.! !

!OrcaTranslatorTest methodsFor: 'test branch' stamp: 'ag 4/12/2011 14:37'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'(function(){var cascadeReceiver$=st.a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '(function(){var cascadeReceiver$=st.a;cascadeReceiver$.slot_(st.b);return cascadeReceiver$.slot_(st.c);}).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '(function(){var cascadeReceiver$=st.a;cascadeReceiver$.slot_be_(st.b, st.d);return cascadeReceiver$.slot_be_(st.c, st.d);}).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 'return (function(){var cascadeReceiver$=st.Object._new();cascadeReceiver$.slot_be_(st.injection, st.string("infovis"));return cascadeReceiver$.yourself();}).apply(this)'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/12/2011 14:36'!
testLoop
	
	self
		assertMatches: '{1. 2. 3} do: [:elem | Js Global alert value: elem]'
		andProduces: 'st.array([st.number(1), st.number(2), st.number(3)]).do_(st.block(function(elem){return st.Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: [:elem | Js Global alert value: elem ]'
		andProduces: 'st.arr.do_(st.block(function(elem){return st.Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: block'
		andProduces: 'st.arr.do_(st.block)'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:18'!
testNonLocalReturn
	
	self
		assertMatches: '
			[ Js Global alert value: ''outer''.
			[Js Global alert value: ''inner''.
			 ^self].
			Js Global alert value: ''end'' ]'
		andProduces: 
'st.block(function(){st.Js.Global().alert().value_(st.string("outer"));st.block(function(){st.Js.Global().alert().value_(st.string("inner"));return st.nonLocalReturn(this);});return st.Js.Global().alert().value_(st.string("end"));})'! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/6/2011 15:52'!
testSelectorTranslation
	
	| assertBlock |
	assertBlock := [ :squeakSelector :jsFunctionname  | 
		self assert: jsFunctionname equals: (OrcaSqueakAstToJsAst jsFunctionNameFor: squeakSelector).].
	
	assertBlock
		value: 'do:forDuration:' value: 'do_forDuration_';
		value: 'do:' value: 'do_';
		value: 'do' value: '_do';
		value: '*+' value: '_times_plus';
		value: '++' value: '_plus_plus'.! !

!OrcaTranslatorTest methodsFor: 'test stories' stamp: 'ag 4/11/2011 16:05'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ Js Global alert value: ''small'' ] ifFalse: [ Js Global alert value: ''big'' ]'
		andProduces:
'st.number(10)._less(st.number(5)).ifTrue_ifFalse_(st.block(function(){return st.Js.Global().alert().value_(st.string("small"));}), st.block(function(){return st.Js.Global().alert().value_(st.string("big"));}))'! !

!OrcaTranslatorTest methodsFor: 'test printing' stamp: 'LT 2/24/2011 15:45:50.248'!
testVarDeclaration
	
	self 
		assertMatches: '|a b c|'
		andProduces: 'var a;var b;var c'! !

OrcaTestCase subclass: #OrcaCodeCleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:05'!
testNoDirtyCategories
	
	self assert: (Utilities classesWithDirtyCategories isEmpty)! !

!OrcaCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:04'!
testNoEmptyCategories
	
	self assert: (Utilities classesWithEmptyCategories isEmpty)! !

OrcaTestCase subclass: #OrcaCodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:21'!
aTestMethod
	
	"Empty method for tests"! !

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:23'!
aTestMethod2
	
	"Empty method for tests"! !

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'LT 3/16/2011 14:48:46.253'!
aTestMethod3
	
	self error: 'testMethod: do not call'.
	self this is only a test message.
	
	"used in testTranslatedMethodContainsAllUsedMessages" ! !

!OrcaCodeFactoryTest methodsFor: 'test methods' stamp: 'lw 4/11/2011 14:37'!
aTestMethod4
	
	Object new.
	OrcaCodeFactoryTest newOn: Number one.
	
	"used in testCollectingReferedClasses" ! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 15:52'!
codeFactory
	"Skip the singleton-pattern"
	
	^ OrcaCodeFactory new! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 4/6/2011 15:52'!
getTestMethod: aSymbol
	
	^ OrcaOMeta2 method: aSymbol of: self class! !

!OrcaCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 1/5/2011 22:57'!
methodNumIn: aClass
	
	^ aClass methodDict size + aClass class methodDict size! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 1/6/2011 11:06'!
testCaching
	
	| factory |
	factory := self codeFactory.
	self assert: factory codeCache size == 0.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod2 of: self class.
	self assert: factory codeCache size == 2.
	factory codeForClass: self class.
	factory codeFor: self class. "If already cached, this works, too"
	self assert: factory codeCache size == ((self methodNumIn: self class) + 1).
	
	factory := self codeFactory.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a'.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a; b'.
	factory codeFor: '1 a; b'.
	self assert: factory codeCache size == 2.! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/6/2011 15:52'!
testCachingClasses
	
	| factory |
	factory := self codeFactory.
	factory codeForClass: self class.
	self assert: factory codeCache size = (self class methodDict size + 1).
	factory codeForClasses: { self class. OrcaNode }.
	self assert: 
		factory codeCache size = 
		((self methodNumIn: self class) + (self methodNumIn: OrcaNode) + 3). "Methods + 2 classes + 1 class-array"! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:20'!
testCachingWithRecompile
	
	| factory size |
	factory := self codeFactory.
	factory codeForClass: self class.
	size := factory codeCache size.
	self class compileAll.
	factory codeForClass: self class.
	self assert: size == factory codeCache size.! !

!OrcaCodeFactoryTest methodsFor: 'as yet unclassified' stamp: 'lw 4/11/2011 14:41'!
testCollectingReferedClasses

	| cacheEntry |
	cacheEntry := self codeFactory cacheObjectForMethod: (self getTestMethod: #aTestMethod4).
	self assert: cacheEntry referedClasses size = 3.
	self assert: (cacheEntry referedClasses includesAllOf: { Number. Object. OrcaCodeFactoryTest })! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/6/2011 15:52'!
testEqualsBlock
	
	| factory block antiBlock method1 method2 |
	factory := self codeFactory.
	block := [ :o1 :o2 | self assert: (factory compareCacheKey: o1 to: o2)].
	antiBlock := [ :o1 :o2 | self deny: (factory compareCacheKey: o1 to: o2)].
	
	block
		value: 'abc' value: 'abc';
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod);
		value: self class value: self class.
	antiBlock
		value: 'abc1' value: 'abc2';
		value: self class value: Object;
		value: 1 value: 2;
		value: 1 value: '1';
		value: (self getTestMethod: #aTestMethod) value: (OrcaOMeta2 method: #asString of: Object);
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod2).
	
	method1 := (self getTestMethod: #aTestMethod).
	self class compileAll.
	method2 := (self getTestMethod: #aTestMethod).
	self deny: method1 == method2. "Should be new objects after recompiling!!"
	block value: method1 value: method2.! !

!OrcaCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 4/12/2011 14:43'!
testTranslatedMethodContainsAllUsedMessages

	| codeFactory cacheEntry |
	codeFactory := self codeFactory.
	cacheEntry := codeFactory cacheObjectForMethod: (self getTestMethod: #aTestMethod3).
	self assert: cacheEntry calledFunctions size = 7.
	self assert: (cacheEntry calledFunctions includesAllOf: { #'error_'. #'_this'. #'_is'. #only. #a. #test. #message }).
	self assert: (cacheEntry calledFunctions keys includesAllOf: { #'error:'. #'this'. #'is'. #only. #a. #test. #message })
! !

OrcaTestCase subclass: #OrcaJavascriptTest
	instanceVariableNames: 'semaphore clientTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OrcaJavascriptTest commentStamp: 'ag 1/26/2011 15:16' prior: 0!
This Test starts the browser with the url of the S2JTestApp.
Then it waits for the test-results from the browser.!

OrcaJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase
	^ currentTestCase! !

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase: anObject
	currentTestCase := anObject! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:51'!
reportJSResult: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'srv 1/31/2011 22:35'!
reportJSResults: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:53'!
reportJSResults: failed and: errors
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: { failed. errors} ].
	^ ''! !

!OrcaJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:30'!
retryTime
	" in seconds "
	
	^ 120! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 13:00'!
clientResponded: aString
	
	self clientTestResult: aString.
	self semaphore signal.! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult
	^ clientTestResult! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult: anObject
	clientTestResult := anObject! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'srv 1/27/2011 16:48'!
killFireFox
	
	CommandShell command: 'pkill firefox;exit'! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 12:57'!
performTest: url tryAgain: tryAgain
	
	^ self performTest: url tryAgain: tryAgain doing: []! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 16:00'!
performTest: url tryAgain: tryAgain doing: aBlock
	
	self runFireFox: url.
	(Delay forSeconds: 3) wait.
	aBlock value.
	(self semaphore waitTimeoutSeconds: self class retryTime) 
		ifTrue: [
			self killFireFox.
			tryAgain ifTrue: [ self performTest: url tryAgain: false doing: aBlock] ] "have a second try, because sometimes the bodys onload is not evaluated"
		ifFalse: [ ^ self clientTestResult ].
	self error: 'No answer from the Javascript-side'.! !

!OrcaJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 12:48'!
runFireFox: url

	CommandShell command: 'firefox -P JSTests ', url, ';exit'! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore
	^ semaphore! !

!OrcaJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore: anObject
	semaphore := anObject! !

!OrcaJavascriptTest methodsFor: 'running' stamp: 'ag 4/6/2011 15:52'!
setUp
	
	self class isOnCIServer ifTrue: [
		OrcaDispatcher forcedRestart.
		self clientTestResult: nil.
		self semaphore: Semaphore new.
		self class currentTestCase: self ].! !

!OrcaJavascriptTest methodsFor: 'running' stamp: 'ag 1/31/2011 12:32'!
tearDown
	
	self class isOnCIServer ifTrue: [
		self killFireFox.
		self class currentTestCase: nil ].! !

!OrcaJavascriptTest methodsFor: 'testing' stamp: 'lw 2/19/2011 20:00'!
testClientside
	
	self class isOnCIServer ifTrue: [ | result |
		result := (self performTest: 'http://localhost:8887/test' tryAgain: true ).
		(result at: 2) = '0' ifFalse: [ self error: 'One of the JS-Tests ended with an error. For more details visit http://localhost:8887/test/'].
		self assert: 0 = (result at: 1) asInteger ].! !

OrcaTestCase subclass: #OrcaSwazooTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OrcaSwazooTests subclass: #OrcaCometHandlerTest
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaCometHandlerTest methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client
	^ client! !

!OrcaCometHandlerTest methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client: anObject
	client := anObject! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/7/2011 17:04:41.367'!
ip

	^ '127.0.0.1'! !

!OrcaCometHandlerTest methodsFor: 'running' stamp: 'LT 4/12/2011 18:54:56.2'!
setUp

	self client: (OrcaTestCometClient from: self ip identifiedBy: 1 ).
	self client application: OrcaTestApp instance reset.
	self client application addClient: self client.
	self client receive: 'test'.
		
! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 19:37:40.244'!
testClientMatchingAtCometHandler

	| client |
	client := (OrcaCometHandler newFor: (OrcaTestApp instance)) getOrCreateClientById: self client identifier andAddress: self ip.
	self assert: client = self client.
	! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 18:55:29.154'!
testDeathAfterMaximumAge 

	self timeOutClient.
	self deny: self client isAlive ! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 19:37:40.252'!
testDispatchApplicationAndCreateCometClient
	
	| clientId response path |

	path := OrcaTestApp uniquePath,'/', OrcaCometHandler pathSuffix, '?id=', self client identifier.
	response := OrcaDispatcher new answerTo: (self basicGetFor: path).
	clientId := response body asString.
	
	self client: ((OrcaCometHandler newFor: OrcaTestApp instance ) getOrCreateClientById: clientId andAddress: self ip).
	self assert: (self client notNil).
	self assert: (self client isAlive).
! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 14:21:34.999'!
testForwardingCometHandler

	| request path response |
	
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix, '?id=', self client identifier.
	request :=  self basicGetFor: path. 
	
	self client addPendingReply: 'test'.
	response := (OrcaCometHandler newFor: OrcaTestApp instance) answerTo: request. 

	self assert: response body asString = 'test'.
! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'SW 1/19/2011 10:17'!
testIsInitiallyAlive


	self assert: self client isAlive! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 19:10:43.816'!
testQueriesKeepAlive
	| path response |
	
	self client timeStampOfLatestRequest: (TimeStamp now - (Duration seconds: 2)).
	path := OrcaTestApp uniquePath, OrcaCometHandler pathSuffix , '?id=', self client identifier.

	[ response := OrcaDispatcher new answerTo: (self basicGetFor: path) ] fork.
	(Delay forMilliseconds: OrcaTestCometClient maximumTimeWithoutContact seconds / 4 * 1000) wait.
	self assert: self client isAlive.
	self timeOutClient.
	! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 19:35:28.015'!
testRemoveDeadClient

	| response path |
	
	path := OrcaTestApp uniquePath, '/', OrcaCometHandler pathSuffix , '?id=', self client identifier.

	self client hasToReply wait.
	"OrcaTestCometClient has exactly 1 second time to poll for the pending answer"
	response := OrcaDispatcher new answerTo: (self basicGetFor: path).

	self assert: (response statusCode = OrcaCometClient HTTPStatusCodeTimeOut).
	
	(Delay forMilliseconds: 1500) wait.
	self assert: OrcaTestApp instance clients isEmpty.! !

!OrcaCometHandlerTest methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 18:55:29.142'!
timeOutClient

	self client timeStampOfLatestRequest: TimeStamp now - OrcaCometClient maximumTimeWithoutContact - (Duration seconds: 1).! !

OrcaSwazooTests subclass: #OrcaDispatcherTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaDispatcherTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testDispatchVirginWebSocketRequest

	| response path httpRequest |
	
	path := OrcaTestApp uniquePath, OrcaWebSocketHandler pathSuffix.
	httpRequest :=	(self basicWSFor: path).
	response := OrcaDispatcher new answerTo: httpRequest.
	
	self assert: (response body asString isAllDigits).! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 08:52'!
arrayFromHexString: aString
	| array stream lookup |
	lookup := '123456789ABCDEF'.
	array := ByteArray new: aString size // 2.
	stream := aString readStream.
	1 to: array size do: [ :i || h l |
		h := stream next.
		h := h = $0 ifTrue: [0] ifFalse: [lookup indexOf: h].
		l := stream next.
		l := l = $0 ifTrue: [0] ifFalse: [lookup indexOf: l].
		array at: i put: ((h bitShift: 4) bitOr: l) ].
	^array! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'LT 4/12/2011 18:34:50.304'!
basicGetFor: aPath

	| requestStream request |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET localhost:8887/', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Connection: Keep-Alive';
		crlf.
	request := HTTPRequest 
		readFrom: (SwazooStream on: requestStream writeBuffer contents).
	request ip: '127.0.0.1'.
	^ request! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 09:08'!
basicWSFor: aPath

	| requestStream request|
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: example.com';
		nextPutLine: 'Connection: Upgrade';
		nextPutLine: 'Sec-WebSocket-Key2: 8 1 8 6    7 ]   8476';
		nextPutLine: 'Sec-WebSocket-Protocol: sample';
		nextPutLine: 'Upgrade: WebSocket';
		nextPutLine: 'Sec-WebSocket-Key1: 2  __4 ''79  #  9"; +K 67  -655';
		nextPutLine: 'Origin: http://example.com';
		nextPutLine: 'Content-Length: 8';
		crlf;
		nextPutLine: (self arrayFromHexString: '598F6AEF77E67CBE') asString.
		
	request := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	request task: (SwazooTask newOn: request).
	request task connection: HTTPConnection new.
	^ request! !

!OrcaSwazooTests methodsFor: 'as yet unclassified' stamp: 'HK 1/12/2011 17:17'!
upgradeGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Upgrade: WebSocket';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

OrcaSwazooTests subclass: #OrcaWebSocketHandlerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaWebSocketHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 4/6/2011 15:52'!
testOpenConnection

	| oldCount response request |

	oldCount := OrcaTestApp instance clients size.

	request := self basicWSFor: OrcaTestApp uniquePath, '/ws'..
	response := (OrcaWebSocketHandler newFor: (OrcaTestApp instance)) answerTo: request.	
	self assert: response isWebSocketHandshake.
	
	self assert: (OrcaTestApp instance clients size = (oldCount +1)).! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 4/6/2011 17:58'!
isOnCIServer
	
	^ true == (Smalltalk at: #OrcaIsOnCIServer ifAbsent: [ nil ])! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 2/3/2011 13:08'!
setIsOnCIServer
	
	^ self setIsOnCIServer: true! !

!OrcaTestCase class methodsFor: 'testing' stamp: 'ag 4/6/2011 17:58'!
setIsOnCIServer: aBoolean
	
	Smalltalk at: #OrcaIsOnCIServer put: aBoolean.! !

!OrcaTestCase methodsFor: 'private' stamp: 'srv 1/5/2011 11:09'!
timeoutForTest
	"remove test-timeout on the CI-server"
	
	^ self class isOnCIServer
		ifTrue: [ 15 * 60 * 1000 ]
		ifFalse: [ ^ super timeoutForTest ]! !

Object subclass: #OrcaSerializationTestObject
	instanceVariableNames: 'otherObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OrcaSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject
	^ otherObject! !

!OrcaSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject: anObject
	otherObject := anObject! !
